import { Component, OnInit, OnDestroy } from '@angular/core';
import { Employee } from 'src/typings';
import { EmployeesService } from 'src/app/api/employees.service';
import { Subscription, pipe, Observable } from 'rxjs';
import { startWith, share, shareReplay, tap } from 'rxjs/operators';

@Component({
  selector: 'ip-employee-container',
  templateUrl: './employee-container.component.html',
  styleUrls: ['./employee-container.component.css']
})
export class EmployeeContainerComponent {

  isLoading = true;
  employees$ = this.employeesService.getAllEmployees().pipe(
    tap(() => this.isLoading = false),
    shareReplay(),
    // share
  );

  // employees: Employee[];
  // private subscription: Subscription;
  constructor(private employeesService: EmployeesService) { }

  // ngOnInit() {
  //   this.subscription = this.employeesService
  //     .getEmployees()
  //     .subscribe(
  //       collection => this.employees = collection);
  // }

  // ngOnDestroy() {
  //   this.subscription.unsubscribe();
  // }

}
